Index: ports/c16x/netif/cs8900if.c
===================================================================
RCS file: /sources/lwip/contrib/ports/c16x/netif/cs8900if.c,v
retrieving revision 1.31
diff -u -0 -p -r1.31 cs8900if.c
--- ports/c16x/netif/cs8900if.c	29 Nov 2006 10:04:47 -0000	1.31
+++ ports/c16x/netif/cs8900if.c	4 Apr 2007 07:15:40 -0000
@@ -115 +115 @@
-#  define DBG_LEVEL 1
+#  define LWIP_DBG_LEVEL 1

Index: ports/ecos/ecos/net/lwip_tcpip/current/include/lwipopts.h
===================================================================
RCS file: /sources/lwip/contrib/ports/ecos/ecos/net/lwip_tcpip/current/include/lwipopts.h,v
retrieving revision 1.8
diff -u -0 -p -r1.8 lwipopts.h
--- ports/ecos/ecos/net/lwip_tcpip/current/include/lwipopts.h	9 Jan 2004 15:47:29 -0000	1.8
+++ ports/ecos/ecos/net/lwip_tcpip/current/include/lwipopts.h	4 Apr 2007 07:22:05 -0000
@@ -227,24 +227,24 @@ a lot of data that needs to be copied, t
-#define MEM_DEBUG               DBG_ON
-#define MEMP_DEBUG              DBG_ON
-#define PBUF_DEBUG              DBG_ON
-#define API_LIB_DEBUG   DBG_ON
-#define API_MSG_DEBUG   DBG_ON 
-#define TCPIP_DEBUG             DBG_ON
-#define NETIF_DEBUG             DBG_ON
-#define SOCKETS_DEBUG   DBG_ON
-#define DEMO_DEBUG              DBG_ON
-#define IP_DEBUG                DBG_ON
-#define IP_REASS_DEBUG  DBG_ON
-#define RAW_DEBUG               DBG_ON
-#define ICMP_DEBUG              DBG_ON
-#define UDP_DEBUG               DBG_ON
-#define TCP_DEBUG               DBG_ON
-#define TCP_INPUT_DEBUG         DBG_ON
-#define TCP_OUTPUT_DEBUG        DBG_ON
-#define TCP_RTO_DEBUG   DBG_ON
-#define TCP_CWND_DEBUG  DBG_ON
-#define TCP_WND_DEBUG   DBG_ON
-#define TCP_FR_DEBUG    DBG_ON
-#define TCP_QLEN_DEBUG  DBG_ON
-#define TCP_RST_DEBUG   DBG_ON
-#define PPP_DEBUG   DBG_ON
+#define MEM_DEBUG               LWIP_DBG_ON
+#define MEMP_DEBUG              LWIP_DBG_ON
+#define PBUF_DEBUG              LWIP_DBG_ON
+#define API_LIB_DEBUG   LWIP_DBG_ON
+#define API_MSG_DEBUG   LWIP_DBG_ON 
+#define TCPIP_DEBUG             LWIP_DBG_ON
+#define NETIF_DEBUG             LWIP_DBG_ON
+#define SOCKETS_DEBUG   LWIP_DBG_ON
+#define DEMO_DEBUG              LWIP_DBG_ON
+#define IP_DEBUG                LWIP_DBG_ON
+#define IP_REASS_DEBUG  LWIP_DBG_ON
+#define RAW_DEBUG               LWIP_DBG_ON
+#define ICMP_DEBUG              LWIP_DBG_ON
+#define UDP_DEBUG               LWIP_DBG_ON
+#define TCP_DEBUG               LWIP_DBG_ON
+#define TCP_INPUT_DEBUG         LWIP_DBG_ON
+#define TCP_OUTPUT_DEBUG        LWIP_DBG_ON
+#define TCP_RTO_DEBUG   LWIP_DBG_ON
+#define TCP_CWND_DEBUG  LWIP_DBG_ON
+#define TCP_WND_DEBUG   LWIP_DBG_ON
+#define TCP_FR_DEBUG    LWIP_DBG_ON
+#define TCP_QLEN_DEBUG  LWIP_DBG_ON
+#define TCP_RST_DEBUG   LWIP_DBG_ON
+#define PPP_DEBUG   LWIP_DBG_ON
@@ -252 +252 @@ a lot of data that needs to be copied, t
-#define DBG_TYPES_ON    (DBG_ON|DBG_TRACE|DBG_STATE|DBG_FRESH|DBG_HALT)
+#define LWIP_DBG_TYPES_ON    (LWIP_DBG_ON|LWIP_DBG_TRACE|LWIP_DBG_STATE|LWIP_DBG_FRESH|LWIP_DBG_HALT)

Index: ports/msvc6/lwipopts.h
===================================================================
RCS file: /sources/lwip/contrib/ports/msvc6/lwipopts.h,v
retrieving revision 1.4
diff -u -0 -p -r1.4 lwipopts.h
--- ports/msvc6/lwipopts.h	28 Apr 2004 23:24:43 -0000	1.4
+++ ports/msvc6/lwipopts.h	4 Apr 2007 07:21:04 -0000
@@ -34 +34 @@
-#define DBG_MIN_LEVEL 0
+#define LWIP_DBG_MIN_LEVEL 0
@@ -36,6 +36,6 @@
-#define TAPIF_DEBUG DBG_ON
-#define TUNIF_DEBUG DBG_OFF
-#define UNIXIF_DEBUG DBG_OFF
-#define DELIF_DEBUG DBG_OFF
-#define SIO_FIFO_DEBUG DBG_OFF
-#define TCPDUMP_DEBUG DBG_ON
+#define TAPIF_DEBUG LWIP_DBG_ON
+#define TUNIF_DEBUG LWIP_DBG_OFF
+#define UNIXIF_DEBUG LWIP_DBG_OFF
+#define DELIF_DEBUG LWIP_DBG_OFF
+#define SIO_FIFO_DEBUG LWIP_DBG_OFF
+#define TCPDUMP_DEBUG LWIP_DBG_ON
@@ -43 +43 @@
-#define PPP_DEBUG               DBG_ON
+#define PPP_DEBUG               LWIP_DBG_ON
@@ -46,22 +46,22 @@
-/*#define MEM_DEBUG               DBG_ON
-#define MEMP_DEBUG              DBG_ON
-#define PBUF_DEBUG              DBG_ON
-#define API_LIB_DEBUG   DBG_ON
-#define API_MSG_DEBUG   DBG_ON */
-#define TCPIP_DEBUG             DBG_ON
-#define NETIF_DEBUG             DBG_ON
-#define SOCKETS_DEBUG   DBG_ON
-#define DEMO_DEBUG              DBG_ON
-#define IP_DEBUG                DBG_ON
-#define IP_REASS_DEBUG  DBG_ON
-#define ICMP_DEBUG              DBG_ON
-#define UDP_DEBUG               DBG_ON
-//#define TCP_DEBUG               DBG_ON
-#define TCP_INPUT_DEBUG         DBG_ON
-#define TCP_OUTPUT_DEBUG        DBG_ON
-/*#define TCP_RTO_DEBUG   DBG_ON
-#define TCP_CWND_DEBUG  DBG_ON
-#define TCP_WND_DEBUG   DBG_ON
-#define TCP_FR_DEBUG    DBG_ON
-#define TCP_QLEN_DEBUG  DBG_ON
-#define TCP_RST_DEBUG   DBG_ON*/
+/*#define MEM_DEBUG               LWIP_DBG_ON
+#define MEMP_DEBUG              LWIP_DBG_ON
+#define PBUF_DEBUG              LWIP_DBG_ON
+#define API_LIB_DEBUG   LWIP_DBG_ON
+#define API_MSG_DEBUG   LWIP_DBG_ON */
+#define TCPIP_DEBUG             LWIP_DBG_ON
+#define NETIF_DEBUG             LWIP_DBG_ON
+#define SOCKETS_DEBUG   LWIP_DBG_ON
+#define DEMO_DEBUG              LWIP_DBG_ON
+#define IP_DEBUG                LWIP_DBG_ON
+#define IP_REASS_DEBUG  LWIP_DBG_ON
+#define ICMP_DEBUG              LWIP_DBG_ON
+#define UDP_DEBUG               LWIP_DBG_ON
+//#define TCP_DEBUG               LWIP_DBG_ON
+#define TCP_INPUT_DEBUG         LWIP_DBG_ON
+#define TCP_OUTPUT_DEBUG        LWIP_DBG_ON
+/*#define TCP_RTO_DEBUG   LWIP_DBG_ON
+#define TCP_CWND_DEBUG  LWIP_DBG_ON
+#define TCP_WND_DEBUG   LWIP_DBG_ON
+#define TCP_FR_DEBUG    LWIP_DBG_ON
+#define TCP_QLEN_DEBUG  LWIP_DBG_ON
+#define TCP_RST_DEBUG   LWIP_DBG_ON*/
@@ -70 +70 @@
-#define DBG_TYPES_ON    (DBG_ON|DBG_TRACE|DBG_STATE|DBG_FRESH|DBG_HALT)
+#define LWIP_DBG_TYPES_ON    (LWIP_DBG_ON|LWIP_DBG_TRACE|LWIP_DBG_STATE|LWIP_DBG_FRESH|LWIP_DBG_HALT)

Index: ports/ti_c6711/proj/lwipopts.h
===================================================================
RCS file: /sources/lwip/contrib/ports/ti_c6711/proj/lwipopts.h,v
retrieving revision 1.2
diff -u -0 -p -r1.2 lwipopts.h
--- ports/ti_c6711/proj/lwipopts.h	7 Nov 2005 00:50:50 -0000	1.2
+++ ports/ti_c6711/proj/lwipopts.h	4 Apr 2007 07:25:36 -0000
@@ -268,2 +268,2 @@ define LWIP_DEBUG in compiler    and fol
-#define DBG_MIN_LEVEL					DBG_LEVEL_SERIOUS
-//DBG_LEVEL_WARNING DBG_LEVEL_SERIOUS DBG_LEVEL_SEVERE
+#define LWIP_DBG_MIN_LEVEL					LWIP_DBG_LEVEL_SERIOUS
+//LWIP_DBG_LEVEL_WARNING LWIP_DBG_LEVEL_SERIOUS LWIP_DBG_LEVEL_SEVERE
@@ -271 +271 @@ define LWIP_DEBUG in compiler    and fol
-#define DBG_TYPES_ON					0//DBG_TRACE | DBG_STATE |DBG_FRESH | DBG_HALT
+#define LWIP_DBG_TYPES_ON					0//LWIP_DBG_TRACE | LWIP_DBG_STATE |LWIP_DBG_FRESH | LWIP_DBG_HALT
@@ -276,29 +276,29 @@ Then, define debug class in opt.h
-#define ETHARP_DEBUG                    DBG_OFF
-#define NETIF_DEBUG                     DBG_OFF
-#define PBUF_DEBUG                      DBG_OFF
-#define API_LIB_DEBUG                   DBG_OFF
-#define API_MSG_DEBUG                   DBG_OFF
-#define SOCKETS_DEBUG                   DBG_OFF
-#define ICMP_DEBUG                      DBG_OFF
-#define INET_DEBUG                      DBG_OFF
-#define IP_DEBUG                        DBG_OFF
-#define IP_REASS_DEBUG                  DBG_OFF
-#define RAW_DEBUG                       DBG_OFF
-#define MEM_DEBUG                       DBG_OFF
-#define MEMP_DEBUG                      DBG_OFF
-#define SYS_DEBUG                       DBG_OFF
-#define TCP_DEBUG                       DBG_OFF
-#define TCP_INPUT_DEBUG                 DBG_OFF
-#define TCP_FR_DEBUG                    DBG_OFF
-#define TCP_RTO_DEBUG                   DBG_OFF
-#define TCP_REXMIT_DEBUG                DBG_OFF
-#define TCP_CWND_DEBUG                  DBG_OFF
-#define TCP_WND_DEBUG                   DBG_OFF
-#define TCP_OUTPUT_DEBUG                DBG_OFF
-#define TCP_RST_DEBUG                   DBG_OFF
-#define TCP_QLEN_DEBUG                  DBG_OFF
-#define UDP_DEBUG                       DBG_OFF
-#define TCPIP_DEBUG                     DBG_OFF
-#define PPP_DEBUG                       DBG_OFF
-#define SLIP_DEBUG                      DBG_OFF
-#define DHCP_DEBUG                      DBG_OFF
+#define ETHARP_DEBUG                    LWIP_DBG_OFF
+#define NETIF_DEBUG                     LWIP_DBG_OFF
+#define PBUF_DEBUG                      LWIP_DBG_OFF
+#define API_LIB_DEBUG                   LWIP_DBG_OFF
+#define API_MSG_DEBUG                   LWIP_DBG_OFF
+#define SOCKETS_DEBUG                   LWIP_DBG_OFF
+#define ICMP_DEBUG                      LWIP_DBG_OFF
+#define INET_DEBUG                      LWIP_DBG_OFF
+#define IP_DEBUG                        LWIP_DBG_OFF
+#define IP_REASS_DEBUG                  LWIP_DBG_OFF
+#define RAW_DEBUG                       LWIP_DBG_OFF
+#define MEM_DEBUG                       LWIP_DBG_OFF
+#define MEMP_DEBUG                      LWIP_DBG_OFF
+#define SYS_DEBUG                       LWIP_DBG_OFF
+#define TCP_DEBUG                       LWIP_DBG_OFF
+#define TCP_INPUT_DEBUG                 LWIP_DBG_OFF
+#define TCP_FR_DEBUG                    LWIP_DBG_OFF
+#define TCP_RTO_DEBUG                   LWIP_DBG_OFF
+#define TCP_REXMIT_DEBUG                LWIP_DBG_OFF
+#define TCP_CWND_DEBUG                  LWIP_DBG_OFF
+#define TCP_WND_DEBUG                   LWIP_DBG_OFF
+#define TCP_OUTPUT_DEBUG                LWIP_DBG_OFF
+#define TCP_RST_DEBUG                   LWIP_DBG_OFF
+#define TCP_QLEN_DEBUG                  LWIP_DBG_OFF
+#define UDP_DEBUG                       LWIP_DBG_OFF
+#define TCPIP_DEBUG                     LWIP_DBG_OFF
+#define PPP_DEBUG                       LWIP_DBG_OFF
+#define SLIP_DEBUG                      LWIP_DBG_OFF
+#define DHCP_DEBUG                      LWIP_DBG_OFF

Index: ports/unix/proj/minimal/lwipopts.h
===================================================================
RCS file: /sources/lwip/contrib/ports/unix/proj/minimal/lwipopts.h,v
retrieving revision 1.12
diff -u -0 -p -r1.12 lwipopts.h
--- ports/unix/proj/minimal/lwipopts.h	6 Oct 2006 10:00:22 -0000	1.12
+++ ports/unix/proj/minimal/lwipopts.h	4 Apr 2007 07:19:18 -0000
@@ -185 +185 @@ a lot of data that needs to be copied, t
-#define DBG_MIN_LEVEL 0
+#define LWIP_DBG_MIN_LEVEL 0
@@ -189 +189 @@ a lot of data that needs to be copied, t
-#define DBG_TYPES_ON (DBG_ON | DBG_TRACE | DBG_STATE | DBG_FRESH)
+#define LWIP_DBG_TYPES_ON (LWIP_DBG_ON | LWIP_DBG_TRACE | LWIP_DBG_STATE | LWIP_DBG_FRESH)
@@ -194 +194 @@ extern unsigned char debug_flags;
-#define DBG_TYPES_ON debug_flags
+#define LWIP_DBG_TYPES_ON debug_flags
@@ -200,37 +200,37 @@ extern unsigned char debug_flags;
-#define DEMO_DEBUG       DBG_OFF
-#define ETHARP_DEBUG     DBG_OFF
-#define NETIF_DEBUG      DBG_OFF
-#define PBUF_DEBUG       DBG_OFF
-#define DELIF_DEBUG      DBG_OFF
-#define DROPIF_DEBUG     DBG_OFF
-#define TUNIF_DEBUG      DBG_OFF
-#define UNIXIF_DEBUG     DBG_OFF
-#define TAPIF_DEBUG      DBG_OFF
-#define SIO_FIFO_DEBUG   DBG_OFF
-#define PPP_DEBUG        DBG_OFF
-#define API_LIB_DEBUG    DBG_OFF
-#define API_MSG_DEBUG    DBG_OFF
-#define SOCKETS_DEBUG    DBG_OFF
-#define ICMP_DEBUG       DBG_OFF
-#define INET_DEBUG       DBG_OFF
-#define IP_DEBUG         DBG_OFF
-#define IP_REASS_DEBUG   DBG_OFF
-#define MEM_DEBUG        DBG_OFF
-#define MEMP_DEBUG       DBG_OFF
-#define SYS_DEBUG        DBG_OFF
-#define TCP_DEBUG        DBG_OFF
-#define TCP_INPUT_DEBUG  DBG_OFF
-#define TCP_FR_DEBUG     DBG_OFF
-#define TCP_RTO_DEBUG    DBG_OFF
-#define TCP_REXMIT_DEBUG DBG_OFF
-#define TCP_CWND_DEBUG   DBG_OFF
-#define TCP_WND_DEBUG    DBG_OFF
-#define TCP_OUTPUT_DEBUG DBG_OFF
-#define TCP_RST_DEBUG    DBG_OFF
-#define TCP_QLEN_DEBUG   DBG_OFF
-#define UDP_DEBUG        DBG_OFF
-#define TCPIP_DEBUG      DBG_OFF
-#define TCPDUMP_DEBUG    DBG_OFF
-#define DHCP_DEBUG       DBG_OFF
-#define SNMP_MSG_DEBUG   DBG_ON
-#define SNMP_MIB_DEBUG   DBG_ON
+#define DEMO_DEBUG       LWIP_DBG_OFF
+#define ETHARP_DEBUG     LWIP_DBG_OFF
+#define NETIF_DEBUG      LWIP_DBG_OFF
+#define PBUF_DEBUG       LWIP_DBG_OFF
+#define DELIF_DEBUG      LWIP_DBG_OFF
+#define DROPIF_DEBUG     LWIP_DBG_OFF
+#define TUNIF_DEBUG      LWIP_DBG_OFF
+#define UNIXIF_DEBUG     LWIP_DBG_OFF
+#define TAPIF_DEBUG      LWIP_DBG_OFF
+#define SIO_FIFO_DEBUG   LWIP_DBG_OFF
+#define PPP_DEBUG        LWIP_DBG_OFF
+#define API_LIB_DEBUG    LWIP_DBG_OFF
+#define API_MSG_DEBUG    LWIP_DBG_OFF
+#define SOCKETS_DEBUG    LWIP_DBG_OFF
+#define ICMP_DEBUG       LWIP_DBG_OFF
+#define INET_DEBUG       LWIP_DBG_OFF
+#define IP_DEBUG         LWIP_DBG_OFF
+#define IP_REASS_DEBUG   LWIP_DBG_OFF
+#define MEM_DEBUG        LWIP_DBG_OFF
+#define MEMP_DEBUG       LWIP_DBG_OFF
+#define SYS_DEBUG        LWIP_DBG_OFF
+#define TCP_DEBUG        LWIP_DBG_OFF
+#define TCP_INPUT_DEBUG  LWIP_DBG_OFF
+#define TCP_FR_DEBUG     LWIP_DBG_OFF
+#define TCP_RTO_DEBUG    LWIP_DBG_OFF
+#define TCP_REXMIT_DEBUG LWIP_DBG_OFF
+#define TCP_CWND_DEBUG   LWIP_DBG_OFF
+#define TCP_WND_DEBUG    LWIP_DBG_OFF
+#define TCP_OUTPUT_DEBUG LWIP_DBG_OFF
+#define TCP_RST_DEBUG    LWIP_DBG_OFF
+#define TCP_QLEN_DEBUG   LWIP_DBG_OFF
+#define UDP_DEBUG        LWIP_DBG_OFF
+#define TCPIP_DEBUG      LWIP_DBG_OFF
+#define TCPDUMP_DEBUG    LWIP_DBG_OFF
+#define DHCP_DEBUG       LWIP_DBG_OFF
+#define SNMP_MSG_DEBUG   LWIP_DBG_ON
+#define SNMP_MIB_DEBUG   LWIP_DBG_ON
Index: ports/unix/proj/minimal/main.c
===================================================================
RCS file: /sources/lwip/contrib/ports/unix/proj/minimal/main.c,v
retrieving revision 1.15
diff -u -0 -p -r1.15 main.c
--- ports/unix/proj/minimal/main.c	21 Mar 2007 15:33:33 -0000	1.15
+++ ports/unix/proj/minimal/main.c	4 Apr 2007 07:23:13 -0000
@@ -120 +120 @@ main(int argc, char **argv)
-  debug_flags = DBG_OFF;

+  debug_flags = LWIP_DBG_OFF;
@@ -125 +125 @@ main(int argc, char **argv)
-        debug_flags |= (DBG_ON|DBG_TRACE|DBG_STATE|DBG_FRESH|DBG_HALT);
+        debug_flags |= (LWIP_DBG_ON|LWIP_DBG_TRACE|LWIP_DBG_STATE|LWIP_DBG_FRESH|LWIP_DBG_HALT);

Index: ports/unix/proj/unixsim/lwipopts.h
===================================================================
RCS file: /sources/lwip/contrib/ports/unix/proj/unixsim/lwipopts.h,v
retrieving revision 1.16
diff -u -0 -p -r1.16 lwipopts.h
--- ports/unix/proj/unixsim/lwipopts.h	21 Aug 2006 10:21:55 -0000	1.16
+++ ports/unix/proj/unixsim/lwipopts.h	4 Apr 2007 07:15:40 -0000
@@ -34 +34 @@
-#define DBG_MIN_LEVEL 0
+#define LWIP_DBG_MIN_LEVEL 0
@@ -36,31 +36,31 @@
-#define TAPIF_DEBUG DBG_ON
-#define TUNIF_DEBUG DBG_OFF
-#define UNIXIF_DEBUG DBG_OFF
-#define DELIF_DEBUG DBG_OFF
-#define SIO_FIFO_DEBUG DBG_OFF
-#define TCPDUMP_DEBUG DBG_ON
-
-#define PPP_DEBUG        DBG_OFF
-#define MEM_DEBUG        DBG_OFF
-#define MEMP_DEBUG       DBG_OFF
-#define PBUF_DEBUG       DBG_OFF
-#define API_LIB_DEBUG    DBG_ON
-#define API_MSG_DEBUG    DBG_ON
-#define TCPIP_DEBUG      DBG_ON
-#define NETIF_DEBUG      DBG_ON
-#define SOCKETS_DEBUG    DBG_ON
-#define DEMO_DEBUG       DBG_ON
-#define IP_DEBUG         DBG_ON
-#define IP_REASS_DEBUG   DBG_ON
-#define RAW_DEBUG        DBG_ON
-#define ICMP_DEBUG       DBG_ON
-#define UDP_DEBUG        DBG_ON
-#define TCP_DEBUG        DBG_ON
-#define TCP_INPUT_DEBUG  DBG_ON
-#define TCP_OUTPUT_DEBUG DBG_ON
-#define TCP_RTO_DEBUG    DBG_ON
-#define TCP_CWND_DEBUG   DBG_ON
-#define TCP_WND_DEBUG    DBG_ON
-#define TCP_FR_DEBUG     DBG_ON
-#define TCP_QLEN_DEBUG   DBG_ON
-#define TCP_RST_DEBUG    DBG_ON
+#define TAPIF_DEBUG LWIP_DBG_ON
+#define TUNIF_DEBUG LWIP_DBG_OFF
+#define UNIXIF_DEBUG LWIP_DBG_OFF
+#define DELIF_DEBUG LWIP_DBG_OFF
+#define SIO_FIFO_DEBUG LWIP_DBG_OFF
+#define TCPDUMP_DEBUG LWIP_DBG_ON
+
+#define PPP_DEBUG        LWIP_DBG_OFF
+#define MEM_DEBUG        LWIP_DBG_OFF
+#define MEMP_DEBUG       LWIP_DBG_OFF
+#define PBUF_DEBUG       LWIP_DBG_OFF
+#define API_LIB_DEBUG    LWIP_DBG_ON
+#define API_MSG_DEBUG    LWIP_DBG_ON
+#define TCPIP_DEBUG      LWIP_DBG_ON
+#define NETIF_DEBUG      LWIP_DBG_ON
+#define SOCKETS_DEBUG    LWIP_DBG_ON
+#define DEMO_DEBUG       LWIP_DBG_ON
+#define IP_DEBUG         LWIP_DBG_ON
+#define IP_REASS_DEBUG   LWIP_DBG_ON
+#define RAW_DEBUG        LWIP_DBG_ON
+#define ICMP_DEBUG       LWIP_DBG_ON
+#define UDP_DEBUG        LWIP_DBG_ON
+#define TCP_DEBUG        LWIP_DBG_ON
+#define TCP_INPUT_DEBUG  LWIP_DBG_ON
+#define TCP_OUTPUT_DEBUG LWIP_DBG_ON
+#define TCP_RTO_DEBUG    LWIP_DBG_ON
+#define TCP_CWND_DEBUG   LWIP_DBG_ON
+#define TCP_WND_DEBUG    LWIP_DBG_ON
+#define TCP_FR_DEBUG     LWIP_DBG_ON
+#define TCP_QLEN_DEBUG   LWIP_DBG_ON
+#define TCP_RST_DEBUG    LWIP_DBG_ON
@@ -69 +69 @@ extern unsigned char debug_flags;
-#define DBG_TYPES_ON debug_flags
+#define LWIP_DBG_TYPES_ON debug_flags
Index: ports/unix/proj/unixsim/simhost.c
===================================================================
RCS file: /sources/lwip/contrib/ports/unix/proj/unixsim/simhost.c,v
retrieving revision 1.19
diff -u -0 -p -r1.19 simhost.c
--- ports/unix/proj/unixsim/simhost.c	26 Feb 2007 20:09:23 -0000	1.19
+++ ports/unix/proj/unixsim/simhost.c	4 Apr 2007 07:23:13 -0000
@@ -423 +423 @@ main(int argc, char **argv)
-  debug_flags = DBG_OFF;
+  debug_flags = LWIP_DBG_OFF;
@@ -428 +428 @@ main(int argc, char **argv)
-        debug_flags |= (DBG_ON|DBG_TRACE|DBG_STATE|DBG_FRESH|DBG_HALT);
+        debug_flags |= (LWIP_DBG_ON|LWIP_DBG_TRACE|LWIP_DBG_STATE|LWIP_DBG_FRESH|LWIP_DBG_HALT);