--- 2313.txt	2010-11-16 23:52:28.000000000 -0800
+++ 4313.txt	2010-11-16 23:52:59.000000000 -0800
@@ -1,10 +1,10 @@
 #------------------------------------------------------------
-# ATtiny2313
+# ATtiny4313
 #------------------------------------------------------------
 
 part
-     id            = "t2313";
-     desc          = "ATtiny2313";
+     id            = "t4313";
+     desc          = "ATtiny4313";
      has_debugwire = yes;
      flash_instr   = 0xB2, 0x0F, 0x1F;
      eeprom_instr  = 0xBB, 0xFE, 0xBB, 0xEE, 0xBB, 0xCC, 0xB2, 0x0D,
@@ -13,7 +13,7 @@ part
      stk500_devcode   = 0x23;
 ##   Use the ATtiny26 devcode:
      avr910_devcode   = 0x5e;
-     signature        = 0x1e 0x91 0x0a;
+     signature        = 0x1e 0x92 0x0d;
      pagel            = 0xD4;
      bs2              = 0xD6;
      reset            = io;
@@ -57,18 +57,18 @@ part
     programlockpolltimeout = 5;
 
      memory "eeprom"
-         size            = 128;
+         size            = 256;
         paged           = no;
         page_size       = 4;
          min_write_delay = 4000;
          max_write_delay = 4500;
          readback_p1     = 0xff;
          readback_p2     = 0xff;
-         read            = "1  0  1  0   0  0  0  0   0 0 0 x  x x x x",
-                           "x a6 a5 a4  a3 a2 a1 a0   o o o o  o o o o";
+         read            = "1   0  1  0   0  0  0  0   0 0 0 x  x x x x",
+                           "a7 a6 a5 a4  a3 a2 a1 a0   o o o o  o o o o";
 
-         write           = "1  1  0  0   0  0  0  0   0 0 0 x  x x x x",
-                           "x a6 a5 a4  a3 a2 a1 a0   i i i i  i i i i";
+         write           = "1   1  0  0   0  0  0  0   0 0 0 x  x x x x",
+                           "a7 a6 a5 a4  a3 a2 a1 a0   i i i i  i i i i";
 
 	loadpage_lo	= "  1   1   0   0      0   0   0   1",
 			  "  0   0   0   0      0   0   0   0",
@@ -77,7 +77,7 @@ part
 
 	writepage	= "  1   1   0   0      0   0   1   0",
 			  "  0   0   x   x      x   x   x   x",
-			  "  x  a6  a5  a4     a3  a2   0   0",
+			  " a7  a6  a5  a4     a3  a2   0   0",
 			  "  x   x   x   x      x   x   x   x";
 
 	mode		= 0x41;
@@ -87,20 +87,20 @@ part
        ;
      memory "flash"
          paged           = yes;
-         size            = 2048;
-         page_size       = 32;
+         size            = 4096;
+         page_size       = 64;
          num_pages       = 64;
          min_write_delay = 4500;
          max_write_delay = 4500;
          readback_p1     = 0xff;
          readback_p2     = 0xff;
          read_lo         = "  0   0   1   0    0   0   0   0",
-                           "  0   0   0   0    0   0  a9  a8",
+                           "  0   0   0   0    0 a10  a9  a8",
                            " a7  a6  a5  a4   a3  a2  a1  a0",
                            "  o   o   o   o    o   o   o   o";
 
          read_hi         = "  0   0   1   0    1   0   0   0",
-                           "  0   0   0   0    0   0  a9  a8",
+                           "  0   0   0   0    0 a10  a9  a8",
                            " a7  a6  a5  a4   a3  a2  a1  a0",
                            "  o   o   o   o    o   o   o   o";
 
@@ -117,17 +117,17 @@ part
                            "  i   i   i   i    i   i   i   i";
 
 # The information in the data sheet of April/2004 is wrong, this works:
-         writepage       = "  0  1  0  0   1  1  0  0",
-                           "  0  0  0  0   0  0 a9 a8",
-                           " a7 a6 a5 a4   x  x  x  x",
-                           "  x  x  x  x   x  x  x  x";
+         writepage       = "  0  1  0  0   1   1  0  0",
+                           "  0  0  0  0   0 a10 a9 a8",
+                           " a7 a6 a5 a4   x   x  x  x",
+                           "  x  x  x  x   x   x  x  x";
 
 	mode		= 0x41;
 	delay		= 6;
 	blocksize	= 32;
 	readsize	= 256;
        ;
-#   ATtiny2313 has Signature Bytes: 0x1E 0x91 0x0A.
+#   ATtiny4313 has Signature Bytes: 0x1E 0x92 0x0D.
      memory "signature"
          size            = 3;
          read            = "0  0  1  1   0  0  0  0   0  0  0  x   x  x  x  x",
@@ -175,7 +175,7 @@ part
         min_write_delay = 9000;
         max_write_delay = 9000;
      ;
-# The Tiny2313 has calibration data for both 4 MHz and 8 MHz.
+# The Tiny4313 has calibration data for both 4 MHz and 8 MHz.
 # The information in the data sheet of April/2004 is wrong, this works:
 
      memory "calibration"